
!TOObject methodsFor: '*tode-pharo-views' stamp: 'dkh 5/29/2011 17:10'!
doit: aString main: main
	^ self
		handleExceptionsDuring: [ 
			Compiler new
				evaluate: aString
				in: nil
				to: self object
				notifying: nil
				ifFail: [ ^ #failedDoit ] ]
		main: main! !

!TOObject methodsFor: '*tode-pharo-views' stamp: 'dkh 5/29/2011 17:31'!
handleExceptions: exceptionSet during: aBlock main: main
	^aBlock
		on: Halt , Error, exceptionSet
		do: [ :ex | 
			| process |
			process := Processor activeProcess.
			(ProcessBrowser isUIProcess: process)
				ifTrue: [ UnhandledError signalForException: ex ]
				ifFalse: [ 
					self
						pushit:
							((TOException new)
								exception: ex)
						selecting: #debug
						main: main.
					TOErrorCommand signal ] ]! !

!TOObject methodsFor: '*tode-pharo-views' stamp: 'dkh 5/29/2011 17:27'!
handleExceptionsDuring: aBlock main: main
	^aBlock
		on: Halt , Error
		do: [ :ex | 
			| process |
			process := Processor activeProcess.
			(ProcessBrowser isUIProcess: process)
				ifTrue: [ UnhandledError signalForException: ex ]
				ifFalse: [ 
					self
						pushit:
							((TOException new)
								exception: ex)
						selecting: #debug
						main: main.
					TOErrorCommand signal ] ]! !
